import greenfoot.*;
import java.util.List;

public class Player extends Actor
{
    int ymove=0;
    int xmove=0;
    int jump=0;
    int fall=0;
    int fallonce=0;
    int falltimer=0;
    int jumplimit=0;
    int leftlimit=0;
    int rightlimit=0;
    int leftblock=0;
    int rightblock=0;
    int speed=2;
    int keyRelease=0;
    
    int health = 20;
    int jumpAmount=8; //Amount of time you have until you stop jumping upward
    int gravityCap=20; //The max speed you can fall
    int fallRate=2; //How much time you have before you accelerate downward when falling
    
    boolean thrown=false;
    
    int v=getImage().getHeight()/2-1; //Up down hit detection position
    int h=getImage().getWidth()/2-1; //Left/right hit detection position
    int sv=getImage().getHeight()/2-2; //Side up/down hit detection position
    int sh=getImage().getWidth()/2-2; //Base left/right hit detection position
    
    public void act()
    {
        getImage().scale(16,32);
        
        v=getImage().getHeight()/2; //Up down hit detection position
        h=getImage().getWidth()/2; //Left/right hit detection position
        sv=getImage().getHeight()/2-1; //Side up/down hit detection position
        sh=getImage().getWidth()/2-1; //Base left/right hit detection position
        
        physics();
        cheats();
        health();
    }
    
    public void health()
    {
        Actor boom = getOneIntersectingObject(Explosion.class);
        if (boom!=null){
            health-=5;
            thrown=true;
            if (boom.getX()>getX()){xmove=-10;}
            if (boom.getX()<getX()){xmove=10;}
            if (boom.getY()>getY()){ymove=-10;}
            if (boom.getY()<getY()){ymove=10;}
        }
        if (health<0){
            health=0;
        }
        if (health>20){
            health=20;
        }
        ((Health) getWorld().getObjects(Health.class).get(0)).set(health);
        if (health==0){
            getWorld().removeObject(this);
        }
    }
    
    public void physics() 
    {
        if (thrown==false){
            if (Greenfoot.isKeyDown("a")){
                xmove=-speed;
                leftlimit=0;
            }else{
                if (leftlimit==0){
                    xmove=0;
                    leftlimit=1;
                }
            }
            if (Greenfoot.isKeyDown("d")){
                xmove=speed;
                rightlimit=0;
            }else{
                if (rightlimit==0){
                    xmove=0;
                    rightlimit=1;
                }
            }
        }else{
            if (xmove<0){
                xmove+=1;
            }
            if (xmove>0){
                xmove-=1;
            }
            if (ymove<0){
                ymove+=1;
            }
            if (xmove==0&&ymove==0){
                thrown=false;
            }
        }
        //Down Collision
        Actor downco = getOneObjectAtOffset( 0, v, Grass.class);
        Actor downco2 = getOneObjectAtOffset( -sh, v, Grass.class);
        Actor downco3 = getOneObjectAtOffset( sh, v, Grass.class);
        Actor downco4 = getOneObjectAtOffset( 0, v, Dirt.class);
        Actor downco5 = getOneObjectAtOffset( -sh, v, Dirt.class);
        Actor downco6 = getOneObjectAtOffset( sh, v, Dirt.class);
        Actor downco7 = getOneObjectAtOffset( 0, v, Stone.class);
        Actor downco8 = getOneObjectAtOffset( -sh, v, Stone.class);
        Actor downco9 = getOneObjectAtOffset( sh, v, Stone.class);
        Actor downco10 = getOneObjectAtOffset( 0, v, LiquoriceLog.class);
        Actor downco11 = getOneObjectAtOffset( -sh, v, LiquoriceLog.class);
        Actor downco12 = getOneObjectAtOffset( sh, v, LiquoriceLog.class);
        Actor downco13 = getOneObjectAtOffset( 0, v, LightLeaves.class);
        Actor downco14 = getOneObjectAtOffset( -sh, v, LightLeaves.class);
        Actor downco15 = getOneObjectAtOffset( sh, v, LightLeaves.class);
        Actor downco16 = getOneObjectAtOffset( 0, v, CopperOre.class);
        Actor downco17 = getOneObjectAtOffset( -sh, v, CopperOre.class);
        Actor downco18 = getOneObjectAtOffset( sh, v, CopperOre.class);
        //Glitch into floor detection
        
        v--;
        
        Actor gdownco = getOneObjectAtOffset( 0, v, Grass.class);
        Actor gdownco2 = getOneObjectAtOffset( -sh, v, Grass.class);
        Actor gdownco3 = getOneObjectAtOffset( sh, v, Grass.class);
        Actor gdownco4 = getOneObjectAtOffset( 0, v, Dirt.class);
        Actor gdownco5 = getOneObjectAtOffset( -sh, v, Dirt.class);
        Actor gdownco6 = getOneObjectAtOffset( sh, v, Dirt.class);
        Actor gdownco7 = getOneObjectAtOffset( 0, v, Stone.class);
        Actor gdownco8 = getOneObjectAtOffset( -sh, v, Stone.class);
        Actor gdownco9 = getOneObjectAtOffset( sh, v, Stone.class);
        Actor gdownco10 = getOneObjectAtOffset( 0, v, LiquoriceLog.class);
        Actor gdownco11 = getOneObjectAtOffset( -sh, v, LiquoriceLog.class);
        Actor gdownco12 = getOneObjectAtOffset( sh, v, LiquoriceLog.class);
        Actor gdownco13 = getOneObjectAtOffset( 0, v, LightLeaves.class);
        Actor gdownco14 = getOneObjectAtOffset( -sh, v, LightLeaves.class);
        Actor gdownco15 = getOneObjectAtOffset( sh, v, LightLeaves.class);
        Actor gdownco16 = getOneObjectAtOffset( 0, v, CopperOre.class);
        Actor gdownco17 = getOneObjectAtOffset( -sh, v, CopperOre.class);
        Actor gdownco18 = getOneObjectAtOffset( sh, v, CopperOre.class);
        
        v++;
        
        //Up Collision
        Actor upco = getOneObjectAtOffset( 0, -v, Grass.class);
        Actor upco2 = getOneObjectAtOffset( 0, -v, Dirt.class);
        Actor upco3 = getOneObjectAtOffset( 0, -v, Stone.class);
        Actor upco4 = getOneObjectAtOffset( 0, -v, LiquoriceLog.class);
        Actor upco5 = getOneObjectAtOffset( 0, -v, LightLeaves.class);
        Actor upco6 = getOneObjectAtOffset( 0, -v, CopperOre.class);
        //Left Collision
        
        h++;
        
        Actor leftco = getOneObjectAtOffset( -h, -sv, Grass.class);
        Actor leftco2 = getOneObjectAtOffset( -h, sv, Grass.class);
        Actor leftco3 = getOneObjectAtOffset( -h, 0, Grass.class);
        Actor leftco4 = getOneObjectAtOffset( -h, -sv, Dirt.class);
        Actor leftco5 = getOneObjectAtOffset( -h, sv, Dirt.class);
        Actor leftco6 = getOneObjectAtOffset( -h, 0, Dirt.class);
        Actor leftco7 = getOneObjectAtOffset( -h, -sv, LiquoriceLog.class);
        Actor leftco8 = getOneObjectAtOffset( -h, sv, LiquoriceLog.class);
        Actor leftco9 = getOneObjectAtOffset( -h, 0, LiquoriceLog.class);
        Actor leftco10 = getOneObjectAtOffset( -h, -sv, LightLeaves.class);
        Actor leftco11 = getOneObjectAtOffset( -h, sv, LightLeaves.class);
        Actor leftco12 = getOneObjectAtOffset( -h, 0, LightLeaves.class);
        Actor leftco13 = getOneObjectAtOffset( -h, -sv, Stone.class);
        Actor leftco14 = getOneObjectAtOffset( -h, sv, Stone.class);
        Actor leftco15 = getOneObjectAtOffset( -h, 0, Stone.class);
        Actor leftco16 = getOneObjectAtOffset( -h, -sv, CopperOre.class);
        Actor leftco17 = getOneObjectAtOffset( -h, sv, CopperOre.class);
        Actor leftco18 = getOneObjectAtOffset( -h, 0, CopperOre.class);
        
        h--;
        
        //Right Collision
        Actor rightco = getOneObjectAtOffset( h, -sv, Grass.class);
        Actor rightco2 = getOneObjectAtOffset( h, sv, Grass.class);
        Actor rightco3 = getOneObjectAtOffset( h, 0, Grass.class);
        Actor rightco4 = getOneObjectAtOffset( h, -sv, Dirt.class);
        Actor rightco5 = getOneObjectAtOffset( h, sv, Dirt.class);
        Actor rightco6 = getOneObjectAtOffset( h, 0, Dirt.class);
        Actor rightco7 = getOneObjectAtOffset( h, -sv, LiquoriceLog.class);
        Actor rightco8 = getOneObjectAtOffset( h, sv, LiquoriceLog.class);
        Actor rightco9 = getOneObjectAtOffset( h, 0, LiquoriceLog.class);
        Actor rightco10 = getOneObjectAtOffset( h, -sv, LightLeaves.class);
        Actor rightco11 = getOneObjectAtOffset( h, sv, LightLeaves.class);
        Actor rightco12 = getOneObjectAtOffset( h, 0, LightLeaves.class);
        Actor rightco13 = getOneObjectAtOffset( h, -sv, Stone.class);
        Actor rightco14 = getOneObjectAtOffset( h, sv, Stone.class);
        Actor rightco15 = getOneObjectAtOffset( h, 0, Stone.class);
        Actor rightco16 = getOneObjectAtOffset( h, -sv, CopperOre.class);
        Actor rightco17 = getOneObjectAtOffset( h, sv, CopperOre.class);
        Actor rightco18 = getOneObjectAtOffset( h, 0, CopperOre.class);
        //Climb Collision
        Actor backco = getOneObjectAtOffset( 0, 0, Ladder.class);
        Actor backco2 = getOneObjectAtOffset( 0, sv, Ladder.class);
        Actor backco3 = getOneObjectAtOffset( 0, -sv, Ladder.class);
        //Collsion Cause and Effect
        if (upco!=null||upco2!=null||upco3!=null||upco4!=null||upco5!=null||upco6!=null){
            fall=1;
            ymove=0;
        }
        
        if (fall==1){
            falltimer+=1;
            if (falltimer==fallRate){
                falltimer=0;
                ymove+=1;
            }
            if (ymove>gravityCap){
                ymove=gravityCap;
            }
            fall=0;
        }
        
        if (downco!=null||downco2!=null||downco3!=null||downco4!=null||downco5!=null||downco6!=null||downco7!=null||downco8!=null||downco9!=null||downco10!=null||downco11!=null||downco12!=null||downco13!=null||downco14!=null||downco15!=null||downco16!=null||downco17!=null||downco18!=null||getY()>getWorld().getHeight()-26){
            if (ymove==7)health-=1;
            if (ymove==8)health-=2;
            if (ymove==9)health-=3;
            if (ymove==10)health-=4;
            if (ymove==11)health-=5;
            if (ymove==12)health-=7;
            if (ymove==13)health-=9;
            if (ymove==14)health-=11;
            if (ymove==15)health-=13;
            if (ymove==16)health-=16;
            if (ymove==17)health-=19;
            if (ymove>17)health-=20;
            ymove=0;
            jumplimit=0;
            jump=0;
            fallonce=0;
            falltimer=0;
        }else{
            fall=1;
            fallonce=1;
        }
        if (gdownco!=null||gdownco2!=null||gdownco3!=null||gdownco4!=null||gdownco5!=null||gdownco6!=null||gdownco7!=null||gdownco8!=null||gdownco9!=null||gdownco10!=null||gdownco11!=null||gdownco12!=null||gdownco13!=null||gdownco14!=null||gdownco15!=null||gdownco16!=null||gdownco17!=null||gdownco18!=null||getY()>getWorld().getHeight()-27){
            setLocation(getX(),getY()-1);
        }
        if (leftco!=null||leftco2!=null||leftco3!=null||leftco4!=null||leftco5!=null||leftco6!=null||leftco7!=null||leftco8!=null||leftco9!=null||leftco10!=null||leftco11!=null||leftco12!=null||leftco13!=null||leftco14!=null||leftco15!=null||leftco16!=null||leftco17!=null||leftco18!=null){
            if (xmove<0){
                xmove=0;
            }
        }
        if (rightco!=null||rightco2!=null||rightco3!=null||rightco4!=null||rightco5!=null||rightco6!=null||rightco7!=null||rightco8!=null||rightco9!=null||rightco10!=null||rightco11!=null||rightco12!=null||rightco13!=null||rightco14!=null||rightco15!=null||rightco16!=null||rightco17!=null||rightco18!=null){
            if (xmove>0){
                xmove=0;
            }
        }
        if (Greenfoot.isKeyDown("space")){
            jump=1;
        }
        if (upco!=null||upco2!=null||upco3!=null||upco4!=null||upco5!=null||upco6!=null){
            jump=0;
        }
        
        if (jump==1){
            if (jumplimit!=jumpAmount){
                falltimer=0;
                jumplimit+=1;
                if (jumplimit>jumpAmount/2){
                    ymove=-1;
                }else{
                    ymove=-3;
                }
            }else{
                fall=1;
            }
        }
        
        //code for climbing on things
        if (backco!=null||backco2!=null||backco3!=null){
            ymove=0;
            falltimer=0;
            jumplimit=0;
            if (Greenfoot.isKeyDown("w")){
                ymove=-2;
            }
            if (Greenfoot.isKeyDown("s")){
                ymove=2;
            }
        }
        
        setLocation(getX()+xmove, getY()+ymove);
        if (shield==true){
            ((Orb) getWorld().getObjects(Orb.class).get(0)).move(xmove,ymove);
            ((Orb2) getWorld().getObjects(Orb2.class).get(0)).move(xmove,ymove);
        }
    }
    boolean shield = false;
    public void cheats(){
        if (Greenfoot.isKeyDown("j")){
            setLocation(getX(),0);
        }
        if (Greenfoot.isKeyDown("o")&&keyRelease==0){
            keyRelease=1;
            if (shield==false){
                shield=true;
                getWorld().addObject(new Orb(),getX(),getY()-37);
                getWorld().addObject(new Orb2(),getX(),getY()+37);
            }else if(shield==true){
                shield=false;
                getWorld().removeObject(((Orb) getWorld().getObjects(Orb.class).get(0)));
                getWorld().removeObject(((Orb2) getWorld().getObjects(Orb2.class).get(0)));
            }
        }else if(! Greenfoot.isKeyDown("o")){
            keyRelease=0;
        }
    }
    
}
